#ifndef SDLTESTER_H_
#define SDLTESTER_H_

/*
	Oyunyapimi.org "Particle Engine 2" adli yazi ile ilgili ornek kodlar.

	Hicbir copyright, copyleft yok. Istediginiz sekilde kodu degistirebilir veya 
	aynen kullanabilirsiniz.

	Saygilar, mentat...
	Kasim 2003
*/


#ifdef WIN32
#pragma comment(lib, "SDL.lib")
#pragma comment(lib, "SDLmain.lib")
#pragma comment(lib, "OpenGL32.lib")
#pragma comment(lib, "glu32.lib")
#include <windows.h>
#endif

#include <GL/gl.h>
#include <GL/glu.h>

#include "SDL.h"

#include <string>
#include "ParticleSystemFactory.h"

class SDLTester
{
	XParticle::ParticleSystemFactory m_factory;
	XParticle::IParticleSystem* m_pParticles;
	void showFPS();
	bool onKeyDown( SDL_keysym* keysym);
	void onMouseButton(short button, int x, int y, short state);
	void initGL(int width, int height);
	void resize(int width, int height);
	long m_wndHeight, m_wndWidth;
public:
	void quit();
	bool init(const std::string& filename);
	void render();
	bool processEvents();
	SDLTester(void){};
	~SDLTester(void){};
};
#endif // SDLTESTER_H_